/*
 * CS23 - lab2
 * extension: stressing pipeline/branch prediciton.
 * Processing time of consistent/predictable branches v.
 * that of random branches.
 */

#include <time.h>
#include <stdio.h>
#include <sys/times.h>
#include <sys/types.h>
#include <stdlib.h>
#include <sys/timeb.h>

main() {
  short i, j;
  double d1, d2, d3,d4; 
  struct timeb t_start, t_end;
  int half_max;

  d1=d2=d3=d4=5.5;
  half_max = RAND_MAX/2;

  srand((unsigned int) time ((time_t *)NULL));

  //predictable braching
  ftime(&t_start);
  for(i=0; i<5000; i++)
    for(j=0; j<1000; j++) {
      rand()<half_max;
      rand()<half_max;
      rand()<half_max;
      if(1) {
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
      }
      else {
	d1=d3;
	d2=d4;
	d3=d1;
	d4=d2;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
      }
      if(1) {
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
      }
      else {
	d1=d3;
	d2=d4;
	d3=d1;
	d4=d2;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
      }
      if(1) {
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
      }
      else {
	d1=d3;
	d2=d4;
	d3=d1;
	d4=d2;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
      }
    }

  ftime(&t_end);
  printf("time taken (predictable conditional): %g\n",
	 ((double) t_end.time - t_start.time)
	 + (t_end.millitm-t_start.millitm)/1000.0);
  
  //random branching
  ftime(&t_start);
  for(i=0; i<10000; i++)
    for(j=0; j<1000; j++) {
      if(rand()<half_max) {
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
      }
      else {
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
      }
      if(rand()<half_max) {
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
      }
      else {
	d1=d3;
	d2=d4;
	d3=d1;
	d4=d2;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
      }
      if(rand()<half_max) {
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
      }
      else {
	d1=d3;
	d2=d4;
	d3=d1;
	d4=d2;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
	d1=d2;
	d2=d3;
	d3=d4;
	d4=d1;
      }
    }

  ftime(&t_end);
  printf("time taken (unpredictable conditional): %g\n",
	 ((double) t_end.time - t_start.time)
	 + (t_end.millitm-t_start.millitm)/1000.0);

}
